// Ex_p5_Audio17_Record.js
// 8-10-2018
// Pour p5.js (Processing en JavaScript)
// OK Processing v 3.3.7 en mode p5.js
// OK en local Firefox Chrome Opera
// Pb en local Safari
// 
// Utilise la library p5.js
// Utilise la library p5.dom.js
// Utilise la library p5.sound.js
//
// /p5jsMode/examples/Sound/ex19_Record_Save/ex19_Record_Save.js
// https://p5js.org/reference/#/p5.SoundFile
//

var mic, recorder, soundFile;

var Bord = 50; // pixels
var Bouton = new Array(3);
var EnTrainDEnregistrer = false;
var EnTrainDeJouer = false;

function setup() {
  Canevas = createCanvas(400, 200);
  Canevas.position(Bord, Bord);

  CouleurVerte = color(50, 150, 50);
  CouleurFond = color(200);
  fill(0);

  Texte1 = createElement('h2', '');
  Texte1.position(20, -10);
  Texte1.html('Ex_p5_Audio17_Record.js');

  for (var i = 0; i < Bouton.length; i++) {
    Bouton[i] = createButton('');
    Bouton[i].style('background-color', CouleurVerte);
    Bouton[i].style('color', color(255, 255, 255));
    Bouton[i].style('font-size', '16px');
    Bouton[i].style('border', 'none');
    Bouton[i].style('border-radius', '6px');
    Bouton[i].position(Bord + 85 + (i * 80), Bord + 35);
    Bouton[i].size(70, 30);
  }
  Bouton[0].html('Record');
  Bouton[0].mouseClicked(ClicBoutonRecord);
  Bouton[1].html('Play');
  Bouton[1].mouseClicked(ClicBoutonPlay);
  Bouton[2].html('Save');
  Bouton[2].mouseClicked(ClicBoutonSave);

  mic = new p5.AudioIn();            // create an audio in
  mic.start();                       // users must manually enable their browser microphone for recording
  recorder = new p5.SoundRecorder(); // create a sound recorder
  recorder.setInput(mic);            // connect mic to recorder
  soundFile = new p5.SoundFile();    // create an empty sound file
  soundFile.playMode('restart');
}

function draw() {
  background(CouleurFond);
  // text(frameCount + "  soundFile.isPlaying() = " + soundFile.isPlaying(), 20, 20); 
  if (!soundFile.isPlaying()) StopPlay();
}

function ClicBoutonRecord() {
  if (EnTrainDeJouer) StopPlay();
  if (EnTrainDEnregistrer) StopRecord();
  else if (mic.enabled) {
    Bouton[0].html('Stop');
    recorder.record(soundFile);
    CouleurFond = color(255, 0, 0);
    EnTrainDEnregistrer = true;
  }
  // return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function ClicBoutonPlay() {
  if (EnTrainDEnregistrer) StopRecord();
  if (EnTrainDeJouer) StopPlay();
  else {
    EnTrainDeJouer = true;
    Bouton[1].html('Stop');
    soundFile.stop(); 
    soundFile.play(); // play the result!
  }
  // return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function ClicBoutonSave() {
  if (EnTrainDEnregistrer) StopRecord();
  if (EnTrainDeJouer) StopPlay();
  saveSound(soundFile, 'mySound.wav'); // save file
  // return false; // https://p5js.org/reference/#/p5/mouseClicked
}

function StopRecord() {
  EnTrainDEnregistrer = false;
  recorder.stop();
  Bouton[0].html('Record');
  CouleurFond = color(200);
}

function StopPlay() {
  soundFile.stop();
  EnTrainDeJouer = false;
  Bouton[1].html('Play');
}
